use beatbaer::error::Error;
use beatbaer::player::Player;
use human_panic::{setup_panic, Metadata};
use libpt::log::info;

fn main() -> Result<(), Error> {
    setup_panic!(
        Metadata::new(env!("CARGO_PKG_NAME"), env!("CARGO_PKG_VERSION"))
            .authors(env!("CARGO_PKG_AUTHORS"))
            .homepage(env!("CARGO_PKG_HOMEPAGE"))
            .support(format!(
                "Public issue tracker at: {}\nor alternatively email: {}",
                env!("CARGO_PKG_REPOSITORY"),
                "software@cscherr.de"
            ))
    );
    let mut player = Player::build()?;
    info!("starting ui");

    eframe::run_native(
        beatbaer::player::TITLE,
        player.gui_options.clone(),
        Box::new(|cc| {
            player.init(cc);
            Ok(Box::new(player))
        }),
    )?;

    info!("leaving ui");
    Ok(())
}
